#!/usr/bin/python

import sys
import test_render

all_tests = [test_render.RenderTestCollection()]

argv = sys.argv[1:]

# parse arguments
help = 0
cmp = 0
log = 0
old = 0
new = 0
list = 0
all = 0
name = ""

if len(argv) > 0:
	name = argv[0];

	all = (name == "-all")
	list = (name == "-list")

	if all or list:
		name = ""
	elif len(argv) > 1:
		option = argv[1]

		cmp = (option == "-cmp")
		log = (option == "-log")
		old = (option == "-old")
		new = (option == "-new")

		if not (cmp or log or old or new):
			help = 1
else:
	help = 1

# print help
if help:
	print "Usage:"
	print "        ./test.py -all                    # run all tests"
	print "        ./test.py -list                   # list all tests"
	print "        ./test.py lostride.blend          # run a single test"
	print "        ./test.py lostride.blend [option] # details of a single test"
	print "        [option] can be: -cmp, -old, -new, -log"
	sys.exit(0)

# count number of tests
if name == "":
	tot = 0
	for collection in all_tests:
		tot += len(collection.tests)
else:
	tot = 1

# run tests
i = 1

for collection in all_tests:
	if name == "" or collection.name == name:
		print "## " + collection.name

		for test in collection.tests:
			if list:
				print test.name
			elif log:
				test.cmd_log()
			elif cmp:
				test.cmd_cmp()
			elif old:
				test.cmd_old()
			elif new:
				test.cmd_new()
			else:
				test.cmd_run(i, tot)

			i += 1

	if not list:
		for test in collection.tests:
			if test.name == name:
				print "## " + collection.name

				if log:
					test.cmd_log()
				elif cmp:
					test.cmd_cmp()
				elif old:
					test.cmd_old()
				elif new:
					test.cmd_new()
				else:
					test.cmd_run(1, 1)

